/**
 * 测试新表格
 */
import React, { Component } from 'react';
import { Card, WhiteSpace } from 'antd-mobile';
import { Row, Col } from 'antd';
import TableCom from '../tableCompon/index';

export default class isNewTable extends Component {
  render() {
    const {
      isRowCol,
      items,
      checkAllHidden,
      isBorder,
      borderStyle,
      fatherCode,
      userId,
      index,
      datas,
      isEdit,
      currentFormKey,
      init,
      get,
      obj,
      mapData,
      form,
      sqlData,
      defaultValues,
      width,
      routerState,
      messageData,
      formCode,
      formId,
      fatherObj,
      style,
      modalInit,
      concealModel,
      taskAssignee,
    } = this.props;
    if (!isEdit) {
      // 展示栏 暂不做处理
      return (
        <>
          {items.map((item, i) => {
            const allhidden = checkAllHidden(items);
            return (
              <div
                key={i}
                style={{
                  marginTop: 0,
                  background: '#ffffff',
                  paddingLeft: 12,
                  width: '100%',
                  flexWrap: 'wrap',
                  ...style,
                }}
              >
                {item.map((ary, j) => {
                  let styles = {};
                  if (ary.content && ary.content.styles) {
                    try {
                      styles = JSON.parse(ary.content.styles);
                    } catch (e) {
                      console.log(`第${i}行第${j}列样式配置有误,${e}`);
                    }
                  }
                  return !allhidden && ary.hidden ? (
                    ''
                  ) : (
                    <div
                      style={{
                        ...styles,
                      }}
                    >
                      <TableCom
                        taskAssignee={taskAssignee} // 提交人
                        userId={userId}
                        modalInit={modalInit}
                        formCode={formCode}
                        formId={formId}
                        i={i}
                        j={j}
                        index={index}
                        fatherCode={fatherCode}
                        datas={datas}
                        isEdit={isEdit}
                        fatherObj={this.props.fatherObj}
                        formKey={currentFormKey}
                        init={init}
                        get={get}
                        key={j}
                        sqlData={sqlData}
                        obj={obj || {}}
                        form={this.props.form}
                        mapData={mapData}
                        json={ary.content}
                        uuid={ary.uuid}
                        routerState={routerState} // 兼容表单设计器路由传参
                        defaultValues={defaultValues || {}}
                        messageData={messageData} // 场景设计器共享变量参数
                        concealModel={concealModel} // 场景设计器路由跳转参数
                      />
                    </div>
                  );
                })}
              </div>
            );
          })}
        </>
      );
    }
    if (isRowCol) {
      return items.map((item, i) => {
        console.log(item);
        const allhidden = checkAllHidden(items);
        return (
          <Row
            style={{
              ...style,
            }}
          >
            {item.map((ary, j) => {
              let styles = {};
              if (ary.content && ary.content.styles) {
                try {
                  styles = JSON.parse(ary.content.styles);
                } catch (e) {
                  console.log(`第${i}行第${j}列样式配置有误,${e}`);
                }
              }
              if (ary.content?.comName === 'Label') {
                console.log(ary);
                return (
                  <Col
                    style={{
                      display: ary.content && ary.content.comName === 'InputHidden' && 'none',
                      ...styles,
                    }}
                    span={ary.content?.labelSpan}
                  >
                    {!allhidden && ary.hidden ? (
                      ''
                    ) : (
                      <>
                        <TableCom
                          formCode={formCode}
                          taskAssignee={taskAssignee}
                          formId={formId}
                          i={i}
                          j={j}
                          index={index}
                          fatherCode={fatherCode}
                          datas={datas}
                          isEdit={isEdit}
                          fatherObj={this.props.fatherObj}
                          formKey={currentFormKey}
                          init={init}
                          get={get}
                          key={j}
                          sqlData={sqlData}
                          obj={obj || {}}
                          form={this.props.form}
                          mapData={mapData}
                          json={ary.content}
                          uuid={ary.uuid}
                          routerState={routerState} // 兼容表单设计器路由传参
                          defaultValues={defaultValues || {}}
                          messageData={messageData} // 场景设计器共享变量参数
                        />
                      </>
                    )}
                  </Col>
                );
              }
              return (
                <Col
                  span={24}
                  style={{
                    display: ary.content && ary.content.comName === 'InputHidden' && 'none',
                    ...styles,
                  }}
                >
                  {!allhidden && ary.hidden ? (
                    ''
                  ) : (
                    <>
                      <TableCom
                        formCode={formCode}
                        taskAssignee={taskAssignee}
                        formId={formId}
                        i={i}
                        j={j}
                        index={index}
                        fatherCode={fatherCode}
                        datas={datas}
                        isEdit={isEdit}
                        fatherObj={this.props.fatherObj}
                        formKey={currentFormKey}
                        init={init}
                        get={get}
                        key={j}
                        sqlData={sqlData}
                        obj={obj || {}}
                        form={this.props.form}
                        mapData={mapData}
                        json={ary.content}
                        uuid={ary.uuid}
                        routerState={routerState} // 兼容表单设计器路由传参
                        defaultValues={defaultValues || {}}
                        messageData={messageData} // 场景设计器共享变量参数
                      />
                    </>
                  )}
                </Col>
              );
            })}
          </Row>
        );
      });
    }
    return items.map((item, i) => {
      const allhidden = checkAllHidden(items);
      return (
        <>
          {' '}
          <Card
            full
            style={{
              ...style,
            }}
            border={false}
          >
            {item.map((ary, j) => {
              if (!ary.content) {
                return;
              }
              let styles = {};
              if (ary.content && ary.content.styles) {
                try {
                  styles = JSON.parse(ary.content.styles);
                } catch (e) {
                  console.log(`第${i}行第${j}列样式配置有误,${e}`);
                }
              }
              if (ary.content && ary.content.comName === 'Label') {
                return (
                  <Card.Header
                    title={
                      !allhidden && ary.hidden ? (
                        ''
                      ) : (
                        <div
                          style={{
                            width: '100%',
                            height: '100%',
                            ...styles,
                            display: ary.content && ary.content.comName === 'InputHidden' && 'none',
                          }}
                        >
                          <TableCom
                            taskAssignee={taskAssignee}
                            modalInit={modalInit}
                            formCode={formCode}
                            formId={formId}
                            i={i}
                            j={j}
                            index={index}
                            fatherCode={fatherCode}
                            datas={datas}
                            isEdit={isEdit}
                            fatherObj={this.props.fatherObj}
                            formKey={currentFormKey}
                            init={init}
                            get={get}
                            key={j}
                            sqlData={sqlData}
                            obj={obj || {}}
                            form={this.props.form}
                            mapData={mapData}
                            json={ary.content}
                            uuid={ary.uuid}
                            routerState={routerState} // 兼容表单设计器路由传参
                            defaultValues={defaultValues || {}}
                            messageData={messageData} // 场景设计器共享变量参数
                          />
                        </div>
                      )
                    }
                  />
                );
              }
              return !allhidden && ary.hidden ? (
                ''
              ) : (
                <Card.Body
                  style={{
                    // textAlign:ary.content&&ary.content.comName === 'Table'?"left":'right'
                    display: ary.content && ary.content.comName === 'InputHidden' && 'none',
                  }}
                >
                  {' '}
                  <div
                    style={{
                      ...styles,
                    }}
                  >
                    <TableCom
                      taskAssignee={taskAssignee}
                      modalInit={modalInit}
                      formCode={formCode}
                      formId={formId}
                      i={i}
                      j={j}
                      index={index}
                      fatherCode={fatherCode}
                      datas={datas}
                      isEdit={isEdit}
                      fatherObj={this.props.fatherObj}
                      formKey={currentFormKey}
                      init={init}
                      get={get}
                      key={j}
                      sqlData={sqlData}
                      obj={obj || {}}
                      form={this.props.form}
                      mapData={mapData}
                      json={ary.content}
                      uuid={ary.uuid}
                      routerState={routerState} // 兼容表单设计器路由传参
                      defaultValues={defaultValues || {}}
                      messageData={messageData} // 场景设计器共享变量参数
                    />
                  </div>
                </Card.Body>
              );
            })}
          </Card>
          <WhiteSpace />
        </>
      );
    });
  }
}
